#include "CatSummary.h"

bool catSummaryExists( const char* fname )
{
	ifstream catfile(fname);
	bool exist;
	if (! catfile )
	{
		exist = 0;
	} else {

		exist = 1;
		catfile.close();
	}
	return exist;
}

void blankCatSummary( const char* fname )
{

	ofstream catfile(fname);
	if (! catfile)
	{
		errstr << "Received error trying to open file for blank catalogue page." << Sas::fatal("ppssumm:FILECREATION");
	}

	HtmlPage page("catpage");

	std::string htitle("Observation " + PpssummCommon::_obsid + " ACDS Cross-Correlation Page");
	errstr << "Generating " << htitle << Sas::message(Msg::App, Msg::Verbose);
	const HtmlTag hr("hr");

	page.title(htitle);
	page.linkbar("catpage");
	page._body << hr;
	page.sub_title(PpssummCommon::_sub_title , PpssummCommon::_obsid + " Cross-Correlation Page");
	page._body << hr;

	page._body << HtmlTag("tt","","No ACDS Cross-Correlation Products were produced.");


	page._body << hr;

	/* Write out the page */
	catfile << page;
	catfile.close();
	
}
