#ifndef __PPSSUMM_FITSTABLE__
#define __PPSSUMM_FITSTABLE__

#include <string>
#include <map>
#include "Dal.h"
#include "Tracer.h"
#include "errstr.h"


template< typename _Ii , typename _Oi >
void getAttribute( Table* tbl, _Ii _first , _Ii _last ,  _Oi _return ,  bool fatalnotfound = 1) 
{
/* Find the attribute keywords in the input contaier, add it to the output container */

	while ( _first != _last ) {

		if ( tbl->hasAttribute(*_first) ) {
			
			*_return++ = tbl->attribute(*_first);

		} else if ( fatalnotfound ) {
			
			errstr << "Unable to find attribute" <<*_first 
				<< Sas::fatal("ppssumm:ATTRIBUTENOTFOUND")
			;

		}
		_first++;

	}
}
/*
template<>
void getAttribute< typename map<std::string , Attribute* >::iterator 
	,  typename map<std::string , Attribute*>::iterator >
( Table* tbl , map<std::string , Attribute*>::iterator _first , map<std::string , Attribute*>::iterator _last ,  bool fatalnotfound = 1) 
{

	while ( _first != _last ) {

		if ( tbl->hasAttribute(_first->first) ) {
			
			_first->second = tbl->attribute(_first->first);

		} else if ( fatalnotfound ) {

			errstr << "Unable to find attribute" << _first->first
				<< Sas::fatal("ppssumm:ATTRIBUTENOTFOUND")
			;

		}
		_first++;

	}
}
*/

#endif

