#ifndef __PPSSUMM_HTMLPAGE__
#define __PPSSUMM_HTMLPAGE__

#include <string>
#include <algorithm>
#include <functional>
#include <iterator>

#include "ppssumm_typedefs.h"
#include "PpssummStatic.h"
#include "HtmlTag.h"

#include "ExtendFitsColumn.h"
#include "string_algo.h"
#include "stripws.h"
#include "STime.h"

#include "param.h"
#include "Tracer.h"
#include "errstr.h"

/*
 * Alternate _init
 * "<?xml version=\"1.0\" encoding=\"UTF-8\"?> <!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\">"
 *
 */
class HtmlPage : public PpssummStatic
{

	/* WARNING
	 * _title is what goes in the <title> tags.
	 */
	public:
	HtmlPage(std::string s) 
		: PpssummStatic()
		, _body("body")
		, _title("title")
	{ 
		_thispage = stripdir(stringParameter(s));
		
		_body << XMMLogo();
		_body << HtmlTag("hr");

		if (! _initdone) {
			_tail << HtmlTag("a","href=\"#top\"","Return to top.");
			_tail << HtmlTag("br");
			_tail << PpssummStatic::version()  ;
			_tail << HtmlTag("br");
			_tail << "Processing Date: " + HtmlPage::_procdate ;
			HtmlPage::_initdone=1;
		}

	}

	static std::string _procdate;

	HtmlTag _body;

	HtmlTag title() const
	{ return _title; }

	HtmlTag& title(std::string s)
	{ _title << s ; return _title; }

	HtmlTag& tail() const
	{ return _tail; }

	HtmlTag& tail(std::string s)
	{ _tail << s ; return _tail; }

	HtmlTag& tail(HtmlTag h)
	{ _tail << h ; return _tail; }

	void sub_title(strlist collect, std::string text);
	
	void linkbar(std::string);

	void make_inst_link(strlist::iterator , strlist::iterator );
	void make_expid_link(strlist::iterator 
		, strlist::iterator 
		, strlist::iterator 
		, strlist::iterator
	);
	void make_name_link(strlist::iterator , strlist::iterator );
	void addTable(strlist , strtable , std::string ="");

	friend std::ostream &operator<<(std::ostream& , HtmlPage );
private:

	static bool _initdone;
	static char _fill;

	static std::string _init;
	static HtmlTag _head;
	HtmlTag _title; 
	static HtmlTag _style;
	static HtmlTag _meta;
	static HtmlTag _tail;

	std::string _thispage;

	static HtmlTag XMMLogo();
};

#endif
