#ifndef __PPSSUMM_PROD_SUMMARY__
#define __PPSSUMM_PROD_SUMMARY__

#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <iterator>
#include "ppssumm_typedefs.h"
#include "PpssummCommon.h"
#include "HtmlTag.h"
#include "HtmlPage.h"
#include "FitsTable.h"
#include "FitsColumn.h"
#include "ExtendFitsColumn.h"
#include "ppssumm_algo.h"
#include "string_algo.h"
#include "STime.h"
#include "Dal.h"
#include "param.h"
#include "Tracer.h"
#include "errstr.h"


class ProductSummary 
: public PpssummCommon 
{
	public:
	ProductSummary(  DataSet* , DataSet* );
	~ProductSummary();

	HtmlPage print();
	void print_exposures_processed(HtmlPage&);
	void print_generic_products(HtmlPage&);
	friend std::ostream &operator<<(std::ostream& os , ProductSummary& sum) 
	{
		os << sum.print();
		return os;
	}

	/* For concatenating exposure information from active instruments */
	strtable exp_table;

	/* For the general pps products */
	strlist  gen_title;
	strtable gen_table;


	private:
        void exposures_processed();
	
	void generic_title();
        void generic_products();

};

#endif
