#ifndef __PPSSUMM_RGS_SUMMARY__
#define __PPSSUMM_RGS_SUMMARY__

#include <vector>
#include <string>
#include <iostream>
#include <algorithm>
#include <iterator>
#include "ppssumm_typedefs.h"
#include "PpssummCommon.h"
#include "HtmlTag.h"
#include "HtmlPage.h"
#include "FitsTable.h"
#include "FitsColumn.h"
#include "ExtendFitsColumn.h"
#include "ppssumm_algo.h"
#include "string_algo.h"
#include "STime.h"
#include "Dal.h"
#include "param.h"
#include "Tracer.h"
#include "errstr.h"


class RgsSummary 
: public PpssummCommon 
{
	public:
	RgsSummary(  DataSet* , DataSet* );
	~RgsSummary();

	HtmlPage print();
	friend std::ostream &operator<<(std::ostream& os , RgsSummary& sum) {

		os << sum.print();
		return os;
	}

	/* For concatenating exposure information from active instruments */
	strlist exp_title;
	strtable exp_table;

	/* For the multi - exposure products */
	strlist  multi_title;
	strtable multi_table;

	/* For each per-exposure product set */
	strlist specific_title;
	keyed_tables specific_table; // The key has to be instrument + exposure.
	
	private:
	void multi_exposure_title();
	void multi_exposure_products();
	void print_multi_exposure_products(HtmlPage&);

        void exposures_processed();
        void print_exposures_processed(HtmlPage&);
	
	void exposure_specific_title();
	void exposure_specific_products();
	void print_exposure_specific_products(HtmlPage&);

};

#endif
