#ifndef __PPSSUMMS_SIMPLEATTRIBUTE__
#define __PPSSUMMS_SIMPLEATTRIBUTE__

#include <string>
#include <ostream>
#include "stripws.h"

#include "Dal.h"

class SAttribute 
{
	// Simple class to store what can be turned into an Attribute
	// Also usefull for storing split summary lines.
public:
	SAttribute( std::string n="" 
		, std::string v="" 
		, std::string c=""
	) : _name(n) , _value(v) , _comment(c) {}
	
	std::string name() const { return _name;}
	SAttribute name(std::string n) 
	{ _name = n; return *this; }

	std::string value() const { return _value; }
	SAttribute& value(std::string v) 
	{ _value = v; return *this;}

	std::string comment() const { return _comment; }
	SAttribute  comment(std::string c)
	{ _comment = c ; return *this; }

	// strictly speeking an attribute name is at most 8 characters long
	std::string name8() const 
	{ return (_name.length() > 8) ? _name.substr(0,8) : _name ; }

	friend std::ostream &operator<<(std::ostream& os , SAttribute att)
	{
		os << "Name/Value/Comment = " 
		<< att.name() << "/" << att.value() << "/" << att.comment() << std::endl;
		return os;
	}
private:
	std::string _name;
	std::string _value;
	std::string _comment;


};

#endif
