#ifndef __PPSSUMM__STRING_ALGO__
#define __PPSSUMM__STRING_ALGO__
#include "ppssumm_typedefs.h"
#include <string>
#include <sstream>
#include <functional>
#include "Dal.h"
#include "Tracer.h"
#include "errstr.h"


std::string::size_type unifylength(strlist::iterator  , strlist::iterator , std::string::size_type =0 , const char =' ');


std::string truncTime( std::string ); 

/*
 * I know there is a toString in stingutil.h but it doesn't work
 * for bool8 or DString.  It returns ^A (true) and ^@ (false) 
 * and leaves trailing ^@ on the end of strings.
 */


/* 
 * WARNING
 * 
 * <string> with g++ 2.95.3 #define 's _C to be 32
 * Don't use it ! Especially not as a template parameter.
 * Aaaaaaaaaaaaaaaaaaaaargh!
 * 
 */


template< typename _T >
struct _toString : unary_function< _T , std::string > 
 
{
	public:
	int _prec;
	_toString(int _p=0) : _prec(_p) {};
	std::string operator()( const _T& _v , ... ) const 
	{
		std::stringstream s;
		if ( _prec > 0 ) s.precision(_prec);
		s << _v;
		return s.str();
		
	}
};

template<>
struct _toString< std::string > : unary_function< std::string , std::string > 
{
	public:
	std::string operator()( const std::string& _v  , ... ) const 
	{
		// Strip trailing \0's from strings
		//return std::string("\0");
		static const char n='\0';
		return _v.substr(0,_v.find_first_of(n));
	}
};

template<>
struct _toString< bool8 > : unary_function< bool8 , std::string > 
{
	public:
	std::string _True, _False;
	_toString(char* pT = "Y" , char* pF ="N" ) : _True(pT) , _False(pF) {}
	std::string operator()( const bool8& _v  , ... ) const 
	{
		return _v ? _True : _False ;
	}
};


struct _notblank
{
	public:
	std::string _ignore;
	_notblank( std::string ign = " \t\n" ) : _ignore(ign) {}
	bool operator()( const std::string s ) {

	/* Simple fn for use with stl algorithms */
		bool rtn;
		if ( s.empty() ) rtn = false;
		else if (_ignore.length()) rtn =  (s.find_first_not_of(_ignore) != std::string::npos) ;
		else rtn = true;

		return rtn;
	}
};
	
#endif
